
module TypeChecker.Monad.Options where

import Control.Monad.Reader

import Interface.Options
import TypeChecker.Monad
import Utils.Monads

-- Options ----------------------------------------------------------------

commandLineOptions :: TC Options
commandLineOptions = envOptions <$> ask

isInteractive :: TC Bool
isInteractive = optInteractive <$> commandLineOptions

setCommandLineOptions :: Options -> TC a -> TC a
setCommandLineOptions opts =
    local $ \e -> e { envOptions = opts }

