-- # import Property

-- backward compatibility
Eq : (A:Set) -> A -> A -> Prop
Eq A a b = a == b

-- some logical axioms

Obj : Set

Hom : Obj -> Obj -> Set

id : (A:Obj) -> Hom A A

comp : (A:Obj) -> (B:Obj) -> (C:Obj) -> Hom A B -> Hom B C -> Hom A C

axId1 : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> Eq (Hom A B) f (comp A A B (id A) f)

axId2 : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> Eq (Hom A B) f (comp A B B f (id B))

assoc : (A:Obj) -> (B:Obj) -> (C:Obj) -> (D:Obj) -> 
         (f:Hom A B) -> (g:Hom B C) -> (h:Hom C D) ->
         Eq (Hom A D) (comp A C D (comp A B C f g) h) (comp A B D f (comp B C D g h))

isMono : (A:Obj) -> (B:Obj) -> Hom A B -> Prop

defMono : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> 
            isMono A B f <=> ((C:Obj) -> (g:Hom C A) -> (h:Hom C A) -> 
            Eq (Hom C B) (comp C A B g f) (comp C A B h f) -> Eq (Hom C A) g h)


A:Obj
B:Obj
C:Obj
k:Hom A B
f:Hom B C

i : Hom A C
i = comp A B C k f

hi : isMono A C i

-- Too difficult on slow machines
prop : isMono A B k
--prop = fol-plugin(assoc,defMono,hi)


