
-- # import nat

data Compare : Nat -> Nat -> Set where
  eq (x : Nat) : Compare x x
  lt (x : Nat) : (y : Nat) -> Compare x (x + suc y)
  gt (x : Nat) : (y : Nat) -> Compare (x + suc y) x

compare : (x, y : Nat) -> Compare x y
compare 0 0	  = eq
compare (suc x) 0 = gt {0} x
compare 0 (suc y) = lt y
compare (suc x) (suc y) with (compare x y) =>
	(suc x)		  (suc x)	     eq	    = eq
	(suc x)		  (suc (x + suc z)) (lt z)  = lt z
	(suc (x + suc z)) (suc x)	    (gt z)  = gt {suc x} z

