
-- # import Property

-- Proof rules for pairs

surjectivePairing (A : Set) (B : A -> Set) :
    (p : { x : A ; B x }) -> p == (p.1, p.2)
surjectivePairing (x,y) = fol-plugin()

pairElimination (A, B : Set) :
    (p : { A ; B }) -> (x : A) -> (y : B) ->
    p == (x,y) ==> p.1 == x /\ p.2 == y

injectivePairing (A, B : Set) :
    (p1, p2 : { A; B }) ->
    p1.1 == p2.1 /\ p1.2 == p2.2 ==> p1 == p2

